package org.jbpm.examples.java;

import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

public class JBPMMailTest {
	

	String deploymentId;
	JBPMRepository jbpmRepository;
	  String groupId1;
	  
	  String groupId2;

	private void initiateJBPMEngine() {
		jbpmRepository = new JBPMRepository();
		jbpmRepository.createProcessEngine();
		deploymentId = jbpmRepository.getRepositoryService().createDeployment()
				.addResourceFromClasspath(
						"org/jbpm/examples/java/mail.jpdl.xml").deploy();
		 // create actors
		jbpmRepository.getIdentityService().createUser("bb", "Big Brother", null, "virendag@rsgsystems.com");
		jbpmRepository.getIdentityService().createUser("obrien", null, "O'Brien", "virendag@rsgsystems.com");
		jbpmRepository.getIdentityService().createUser("charr", null, "Charrington", "virendag@rsgsystems.com");
	    groupId1 = jbpmRepository.getIdentityService().createGroup("thinkpol");
	    groupId2 = jbpmRepository.getIdentityService().createGroup("innerparty");
	    jbpmRepository.getIdentityService().createMembership("obrien", groupId2);
	    jbpmRepository.getIdentityService().createMembership("charr", groupId1);
	    jbpmRepository.getIdentityService().createMembership("obrien", groupId1);
	}

	private void deleteDeployment() {
		jbpmRepository.getIdentityService().deleteUser("bb");
		jbpmRepository.getIdentityService().deleteUser("obrien");
		jbpmRepository.getIdentityService().deleteUser("charr");
		    
		jbpmRepository.getIdentityService().deleteGroup(groupId1);
		jbpmRepository.getIdentityService().deleteGroup(groupId2);
		jbpmRepository.deleteRegisteredDeployments();
		String errorMsg = jbpmRepository.verifyDbClean();
	}

	private void testJavaInstantiate() {
		 String newspaper = "times";
		    Calendar calendar = Calendar.getInstance();
		    calendar.clear();
		    calendar.set(1983, Calendar.DECEMBER, 3);
		    Date date = calendar.getTime();
		    // assemble variables
		    Map<String, Object> variables = new HashMap<String, Object>();
		    variables.put("newspaper", newspaper);
		    variables.put("date", date);
		    // start process instance
		    jbpmRepository.getExecutionService().startProcessInstanceByKey("InlineMail", variables);
		    
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		JBPMMailTest jBPMMailTest = new JBPMMailTest();
		jBPMMailTest.initiateJBPMEngine();
		jBPMMailTest.testJavaInstantiate();
		//testHandShake.deleteDeployment();
	}

}
